package com.zt.plat.module.qms.business.config.service;

import cn.hutool.core.collection.CollUtil;
import com.zt.plat.module.qms.business.config.controller.vo.ConfigAssayMethodProjectPageReqVO;
import com.zt.plat.module.qms.business.config.controller.vo.ConfigAssayMethodProjectRespVO;
import com.zt.plat.module.qms.business.config.controller.vo.ConfigAssayMethodProjectSaveReqVO;
import org.springframework.stereotype.Service;
import jakarta.annotation.Resource;
import org.springframework.validation.annotation.Validated;

import java.util.*;
import com.zt.plat.module.qms.business.config.controller.vo.*;
import com.zt.plat.module.qms.business.config.dal.dataobject.ConfigAssayMethodProjectDO;
import com.zt.plat.framework.common.pojo.PageResult;
import com.zt.plat.framework.common.util.object.BeanUtils;

import com.zt.plat.module.qms.business.config.dal.mapper.ConfigAssayMethodProjectMapper;

import static com.zt.plat.framework.common.exception.util.ServiceExceptionUtil.exception;
import static com.zt.plat.framework.common.util.collection.CollectionUtils.convertList;
import static com.zt.plat.module.qms.enums.ErrorCodeConstants.CONFIG_ASSAY_METHOD_PROJECT_NOT_EXISTS;

/**
 * 检测方法分析项目配置 Service 实现类
 *
 * @author 后台管理
 */
@Service
@Validated
public class ConfigAssayMethodProjectServiceImpl implements ConfigAssayMethodProjectService {

    @Resource
    private ConfigAssayMethodProjectMapper configAssayMethodProjectMapper;

    @Override
    public ConfigAssayMethodProjectRespVO createConfigAssayMethodProject(ConfigAssayMethodProjectSaveReqVO createReqVO) {
        // 插入
        ConfigAssayMethodProjectDO configAssayMethodProject = BeanUtils.toBean(createReqVO, ConfigAssayMethodProjectDO.class);
        configAssayMethodProjectMapper.insert(configAssayMethodProject);
        // 返回
        return BeanUtils.toBean(configAssayMethodProject, ConfigAssayMethodProjectRespVO.class);
    }

    @Override
    public void updateConfigAssayMethodProject(ConfigAssayMethodProjectSaveReqVO updateReqVO) {
        // 校验存在
        validateConfigAssayMethodProjectExists(updateReqVO.getId());
        // 更新
        ConfigAssayMethodProjectDO updateObj = BeanUtils.toBean(updateReqVO, ConfigAssayMethodProjectDO.class);
        configAssayMethodProjectMapper.updateById(updateObj);
    }

    @Override
    public void deleteConfigAssayMethodProject(Long id) {
        // 校验存在
        validateConfigAssayMethodProjectExists(id);
        // 删除
        configAssayMethodProjectMapper.deleteById(id);
    }

    @Override
        public void deleteConfigAssayMethodProjectListByIds(List<Long> ids) {
        // 校验存在
        validateConfigAssayMethodProjectExists(ids);
        // 删除
        configAssayMethodProjectMapper.deleteByIds(ids);
        }

    private void validateConfigAssayMethodProjectExists(List<Long> ids) {
        List<ConfigAssayMethodProjectDO> list = configAssayMethodProjectMapper.selectByIds(ids);
        if (CollUtil.isEmpty(list) || list.size() != ids.size()) {
            throw exception(CONFIG_ASSAY_METHOD_PROJECT_NOT_EXISTS);
        }
    }

    private void validateConfigAssayMethodProjectExists(Long id) {
        if (configAssayMethodProjectMapper.selectById(id) == null) {
            throw exception(CONFIG_ASSAY_METHOD_PROJECT_NOT_EXISTS);
        }
    }

    @Override
    public ConfigAssayMethodProjectDO getConfigAssayMethodProject(Long id) {
        return configAssayMethodProjectMapper.selectById(id);
    }

    @Override
    public PageResult<ConfigAssayMethodProjectDO> getConfigAssayMethodProjectPage(ConfigAssayMethodProjectPageReqVO pageReqVO) {
        return configAssayMethodProjectMapper.selectPage(pageReqVO);
    }

}